/* The following code was generated by JFlex 1.4.3 on 05/06/2019 11:09 */

/* Copyright (C) 2018 UPS/IRIT
*
* This program is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
* 
* Original authors: Jean-Paul Bodeveix, Mamoun Filali, Regis Spadotti, Guillaume Verdier (UPS/IRIT)
* Modified by: Marc Pantel (INPT/IRIT)
* 
*/
package fr.irit.fiacre.etoile.expander ;

import java_cup.runtime.*;
import java.io.FileReader;
import java.io.File;
import java.io.FileNotFoundException;



/**
 * This class is a scanner generated by 
 * <a href="http://www.jflex.de/">JFlex</a> 1.4.3
 * on 05/06/2019 11:09 from the specification file
 * <tt>src/Scanner.jflex</tt>
 */
class Scanner extends sym implements java_cup.runtime.Scanner {

  /** This character denotes the end of file */
  public static final int YYEOF = -1;

  /** initial size of the lookahead buffer */
  private static final int ZZ_BUFFERSIZE = 16384;

  /** lexical states */
  public static final int FILENAME = 4;
  public static final int ENDLINE = 6;
  public static final int YYINITIAL = 0;
  public static final int LINENUMBER = 2;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = { 
     0,  1,  2,  2,  3,  3,  4, 4
  };

  /** 
   * Translates characters to character classes
   */
  private static final String ZZ_CMAP_PACKED = 
    "\11\0\1\3\1\2\1\0\1\3\1\1\22\0\1\14\1\64\1\15"+
    "\1\13\1\62\1\57\1\54\1\0\1\71\1\72\1\5\1\56\1\10"+
    "\1\53\1\7\1\4\1\31\1\32\10\12\1\65\1\66\1\63\1\50"+
    "\1\51\1\47\1\60\32\11\1\67\1\0\1\70\1\61\1\6\1\0"+
    "\1\36\1\42\1\25\1\26\1\24\1\41\1\45\1\44\1\16\1\11"+
    "\1\40\1\37\1\34\1\17\1\22\1\33\1\27\1\23\1\30\1\20"+
    "\1\21\1\46\1\43\1\52\1\35\1\11\1\73\1\55\1\74\uff82\0";

  /** 
   * Translates characters to character classes
   */
  private static final char [] ZZ_CMAP = zzUnpackCMap(ZZ_CMAP_PACKED);

  /** 
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\5\0\1\1\2\2\1\3\1\4\1\5\1\6\1\7"+
    "\1\10\1\11\1\1\23\7\1\12\1\13\1\14\1\15"+
    "\1\16\1\17\1\20\1\21\1\22\1\23\1\24\1\25"+
    "\1\26\1\27\1\30\1\31\1\32\1\33\1\34\1\35"+
    "\1\36\1\37\1\40\1\0\2\41\2\0\1\42\2\0"+
    "\1\43\1\44\1\45\1\46\3\7\1\47\5\7\1\50"+
    "\1\7\1\51\1\52\11\7\1\53\40\7\1\54\1\55"+
    "\1\56\2\0\1\57\1\60\1\61\1\62\1\63\1\64"+
    "\1\65\1\66\1\67\1\70\1\71\1\72\1\73\2\0"+
    "\1\74\1\75\1\7\1\76\3\7\1\77\1\100\2\7"+
    "\1\101\4\7\1\102\4\7\1\103\23\7\1\104\1\7"+
    "\1\105\1\106\3\7\1\107\3\7\1\110\7\7\1\111"+
    "\12\7\1\112\1\7\3\0\1\2\1\113\1\7\1\114"+
    "\1\115\1\116\1\117\1\120\4\7\1\121\5\7\1\122"+
    "\4\7\1\123\6\7\1\124\1\125\14\7\1\126\6\7"+
    "\1\127\1\7\1\130\1\7\1\131\4\7\1\132\3\7"+
    "\2\0\1\7\1\133\1\134\3\7\1\135\1\7\1\136"+
    "\1\137\1\140\1\7\1\141\4\7\1\142\1\143\7\7"+
    "\1\144\3\7\1\145\3\7\1\146\1\7\1\147\1\150"+
    "\1\7\1\151\3\7\1\152\1\153\1\154\1\155\1\156"+
    "\1\0\1\7\1\157\1\160\2\7\1\161\5\7\1\162"+
    "\1\163\5\7\1\164\1\165\1\166\1\167\1\170\1\171"+
    "\4\7\1\172\1\173\1\174\1\7\1\175\1\176\1\177"+
    "\1\200\1\7\1\201\1\202\2\7\1\203\2\7\1\204"+
    "\1\205\1\206\1\207\1\210\3\7\1\211\1\212\1\213"+
    "\1\7\1\214\6\7\1\215\2\7\1\216";

  private static int [] zzUnpackAction() {
    int [] result = new int[403];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** 
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\75\0\172\0\267\0\364\0\u0131\0\u016e\0\u0131"+
    "\0\u01ab\0\u0131\0\u01e8\0\u0131\0\u0225\0\u0262\0\u0131\0\u029f"+
    "\0\u02dc\0\u0319\0\u0356\0\u0393\0\u03d0\0\u040d\0\u044a\0\u0487"+
    "\0\u04c4\0\u0501\0\u053e\0\u057b\0\u05b8\0\u05f5\0\u0632\0\u066f"+
    "\0\u06ac\0\u06e9\0\u0726\0\u0131\0\u0763\0\u07a0\0\u07dd\0\u0131"+
    "\0\u081a\0\u0131\0\u0131\0\u0131\0\u0131\0\u0131\0\u0857\0\u0131"+
    "\0\u0894\0\u0131\0\u08d1\0\u0131\0\u090e\0\u0131\0\u094b\0\u0131"+
    "\0\u0131\0\u0988\0\u09c5\0\u0a02\0\u0131\0\u0a3f\0\u0a7c\0\u0ab9"+
    "\0\u0af6\0\u029f\0\u0131\0\u0b33\0\u0225\0\u0225\0\u0b70\0\u0bad"+
    "\0\u0bea\0\u0225\0\u0c27\0\u0c64\0\u0ca1\0\u0cde\0\u0d1b\0\u0225"+
    "\0\u0d58\0\u0225\0\u0225\0\u0d95\0\u0dd2\0\u0e0f\0\u0e4c\0\u0e89"+
    "\0\u0ec6\0\u0f03\0\u0f40\0\u0f7d\0\u0225\0\u0fba\0\u0ff7\0\u1034"+
    "\0\u1071\0\u10ae\0\u10eb\0\u1128\0\u1165\0\u11a2\0\u11df\0\u121c"+
    "\0\u1259\0\u1296\0\u12d3\0\u1310\0\u134d\0\u138a\0\u13c7\0\u1404"+
    "\0\u1441\0\u147e\0\u14bb\0\u14f8\0\u1535\0\u1572\0\u15af\0\u15ec"+
    "\0\u1629\0\u1666\0\u16a3\0\u16e0\0\u171d\0\u0131\0\u0131\0\u0131"+
    "\0\u175a\0\u1797\0\u0131\0\u0131\0\u0131\0\u0131\0\u0131\0\u0131"+
    "\0\u0131\0\u0131\0\u0131\0\u0131\0\u0131\0\u0131\0\u0131\0\u17d4"+
    "\0\u1811\0\u0131\0\u0af6\0\u184e\0\u0225\0\u188b\0\u18c8\0\u1905"+
    "\0\u0225\0\u0225\0\u1942\0\u197f\0\u0225\0\u19bc\0\u19f9\0\u1a36"+
    "\0\u1a73\0\u0225\0\u1ab0\0\u1aed\0\u1b2a\0\u1b67\0\u0225\0\u1ba4"+
    "\0\u1be1\0\u1c1e\0\u1c5b\0\u1c98\0\u1cd5\0\u1d12\0\u1d4f\0\u1d8c"+
    "\0\u1dc9\0\u1e06\0\u1e43\0\u1e80\0\u1ebd\0\u1efa\0\u1f37\0\u1f74"+
    "\0\u1fb1\0\u1fee\0\u0225\0\u202b\0\u0225\0\u0225\0\u2068\0\u20a5"+
    "\0\u20e2\0\u0225\0\u211f\0\u215c\0\u2199\0\u0225\0\u21d6\0\u2213"+
    "\0\u2250\0\u228d\0\u22ca\0\u2307\0\u2344\0\u2381\0\u23be\0\u23fb"+
    "\0\u2438\0\u2475\0\u24b2\0\u24ef\0\u252c\0\u2569\0\u25a6\0\u25e3"+
    "\0\u0225\0\u2620\0\u265d\0\u269a\0\u26d7\0\u17d4\0\u0225\0\u2714"+
    "\0\u0225\0\u0225\0\u0225\0\u0225\0\u0225\0\u2751\0\u278e\0\u27cb"+
    "\0\u2808\0\u0225\0\u2845\0\u2882\0\u28bf\0\u28fc\0\u2939\0\u0225"+
    "\0\u2976\0\u29b3\0\u29f0\0\u2a2d\0\u0225\0\u2a6a\0\u2aa7\0\u2ae4"+
    "\0\u2b21\0\u2b5e\0\u2b9b\0\u0225\0\u0225\0\u2bd8\0\u2c15\0\u2c52"+
    "\0\u2c8f\0\u2ccc\0\u2d09\0\u2d46\0\u2d83\0\u2dc0\0\u2dfd\0\u2e3a"+
    "\0\u2e77\0\u0225\0\u2eb4\0\u2ef1\0\u2f2e\0\u2f6b\0\u2fa8\0\u2fe5"+
    "\0\u0225\0\u3022\0\u0225\0\u305f\0\u0225\0\u309c\0\u30d9\0\u3116"+
    "\0\u3153\0\u0225\0\u3190\0\u31cd\0\u320a\0\u3247\0\u3284\0\u32c1"+
    "\0\u0225\0\u0225\0\u32fe\0\u333b\0\u3378\0\u0225\0\u33b5\0\u0225"+
    "\0\u0225\0\u0225\0\u33f2\0\u342f\0\u346c\0\u34a9\0\u34e6\0\u3523"+
    "\0\u0225\0\u3560\0\u359d\0\u35da\0\u3617\0\u3654\0\u3691\0\u36ce"+
    "\0\u370b\0\u0225\0\u3748\0\u3785\0\u37c2\0\u0225\0\u37ff\0\u383c"+
    "\0\u3879\0\u0225\0\u38b6\0\u0225\0\u0225\0\u38f3\0\u0225\0\u3930"+
    "\0\u396d\0\u39aa\0\u0225\0\u0225\0\u0225\0\u0225\0\u0131\0\u39e7"+
    "\0\u3a24\0\u0225\0\u0225\0\u3a61\0\u3a9e\0\u0225\0\u3adb\0\u3b18"+
    "\0\u3b55\0\u3b92\0\u3bcf\0\u0225\0\u0225\0\u3c0c\0\u3c49\0\u3c86"+
    "\0\u3cc3\0\u3d00\0\u0225\0\u0225\0\u0225\0\u0225\0\u0225\0\u0225"+
    "\0\u3d3d\0\u3d7a\0\u3db7\0\u3df4\0\u0225\0\u0225\0\u0131\0\u3e31"+
    "\0\u0225\0\u0225\0\u0225\0\u0225\0\u3e6e\0\u0225\0\u0225\0\u3eab"+
    "\0\u3ee8\0\u0225\0\u3f25\0\u3f62\0\u0225\0\u0225\0\u0225\0\u0225"+
    "\0\u0225\0\u3f9f\0\u3fdc\0\u4019\0\u0225\0\u0225\0\u0225\0\u4056"+
    "\0\u0225\0\u4093\0\u40d0\0\u410d\0\u414a\0\u4187\0\u41c4\0\u0225"+
    "\0\u4201\0\u423e\0\u0225";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[403];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /** 
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpackTrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\1\6\1\7\2\10\1\11\1\12\1\6\1\13\1\14"+
    "\1\15\1\16\1\17\1\10\1\20\1\21\1\22\1\23"+
    "\1\24\1\25\1\26\1\27\1\30\1\31\1\32\1\33"+
    "\2\16\1\34\1\35\1\15\1\36\1\37\1\15\1\40"+
    "\1\41\1\42\2\15\1\43\1\44\1\45\1\46\1\15"+
    "\1\47\1\50\1\51\1\52\1\53\1\54\1\55\1\56"+
    "\1\57\1\60\1\61\1\62\1\63\1\64\1\65\1\66"+
    "\1\67\1\70\1\6\1\7\2\10\1\11\1\12\1\6"+
    "\1\13\1\14\1\15\1\16\1\71\1\10\1\20\1\21"+
    "\1\22\1\23\1\24\1\25\1\26\1\27\1\30\1\31"+
    "\1\32\1\33\2\16\1\34\1\35\1\15\1\36\1\37"+
    "\1\15\1\40\1\41\1\42\2\15\1\43\1\44\1\45"+
    "\1\46\1\15\1\47\1\50\1\51\1\52\1\53\1\54"+
    "\1\55\1\56\1\57\1\60\1\61\1\62\1\63\1\64"+
    "\1\65\1\66\1\67\1\70\12\0\1\72\1\0\1\3"+
    "\14\0\2\72\56\0\1\4\1\73\57\0\1\5\1\74"+
    "\1\75\72\5\77\0\1\10\76\0\1\76\1\77\76\0"+
    "\1\100\73\0\1\15\2\0\2\15\3\0\31\15\3\0"+
    "\1\15\31\0\1\101\2\0\1\16\16\0\2\16\42\0"+
    "\15\102\1\103\57\102\6\0\1\15\2\0\2\15\3\0"+
    "\1\15\1\104\10\15\1\105\10\15\1\106\5\15\3\0"+
    "\1\15\30\0\1\15\2\0\2\15\3\0\3\15\1\107"+
    "\1\110\13\15\1\111\10\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\4\15\1\112\1\113\11\15\1\114"+
    "\1\115\5\15\1\116\2\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\1\15\1\117\27\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\1\15\1\120\1\15"+
    "\1\121\1\15\1\122\15\15\1\123\5\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\6\15\1\124\22\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\1\15"+
    "\1\125\14\15\1\126\2\15\1\127\6\15\1\130\3\0"+
    "\1\131\30\0\1\15\2\0\2\15\3\0\4\15\1\132"+
    "\13\15\1\133\5\15\1\134\2\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\4\15\1\135\1\15\1\136"+
    "\22\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\3\15\1\137\25\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\2\15\1\140\3\15\1\141\10\15\1\142"+
    "\11\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\4\15\1\143\1\144\12\15\1\145\10\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\4\15\1\146\24\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\1\15"+
    "\1\147\3\15\1\150\4\15\1\151\2\15\1\152\3\15"+
    "\1\153\1\15\1\154\1\155\4\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\2\15\1\156\1\15\1\157"+
    "\1\15\1\160\11\15\1\161\10\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\1\162\2\15\1\163\1\164"+
    "\1\165\12\15\1\166\10\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\4\15\1\167\1\15\1\170\22\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\1\171"+
    "\4\15\1\172\12\15\1\173\5\15\1\174\2\15\3\0"+
    "\1\15\30\0\1\15\2\0\2\15\3\0\20\15\1\175"+
    "\10\15\3\0\1\15\73\0\1\176\73\0\1\177\1\200"+
    "\43\0\1\201\20\0\1\202\7\0\1\203\74\0\1\204"+
    "\3\0\1\205\16\0\1\206\50\0\1\207\1\210\3\0"+
    "\1\211\5\0\1\212\61\0\1\213\114\0\1\214\76\0"+
    "\1\215\57\0\1\216\31\0\1\72\16\0\2\72\42\0"+
    "\15\73\1\217\57\73\2\0\1\75\72\0\1\76\1\7"+
    "\1\10\72\76\5\220\1\221\67\220\7\0\1\222\77\0"+
    "\1\223\16\0\2\223\50\0\1\15\2\0\2\15\3\0"+
    "\1\224\1\15\1\225\20\15\1\226\5\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\21\15\1\227\7\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\1\15"+
    "\1\230\1\231\26\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\2\15\1\232\26\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\3\15\1\233\25\15\3\0"+
    "\1\15\30\0\1\15\2\0\2\15\3\0\15\15\1\234"+
    "\13\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\27\15\1\235\1\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\6\15\1\236\22\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\1\237\1\15\1\240\16\15"+
    "\1\241\7\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\2\15\1\242\26\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\7\15\1\243\10\15\1\244\1\245"+
    "\7\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\2\15\1\246\5\15\1\247\1\250\17\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\15\15\1\251\13\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\12\15"+
    "\1\252\16\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\6\15\1\253\22\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\1\254\30\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\1\15\1\255\14\15\1\256"+
    "\12\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\12\15\1\257\16\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\20\15\1\260\10\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\11\15\1\261\6\15\1\262"+
    "\10\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\6\15\1\263\22\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\20\15\1\264\10\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\21\15\1\265\7\15\3\0"+
    "\1\15\30\0\1\15\2\0\2\15\3\0\1\15\1\266"+
    "\27\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\5\15\1\267\23\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\1\270\3\15\1\271\1\15\1\272\22\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\5\15"+
    "\1\273\23\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\5\15\1\274\23\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\10\15\1\275\6\15\1\276\11\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\5\15"+
    "\1\277\23\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\12\15\1\300\16\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\15\15\1\301\13\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\21\15\1\302\3\15"+
    "\1\303\3\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\2\15\1\304\26\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\12\15\1\305\16\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\21\15\1\306\7\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\4\15"+
    "\1\307\24\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\1\15\1\310\16\15\1\311\10\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\12\15\1\312\16\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\5\15"+
    "\1\313\1\314\22\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\21\15\1\315\7\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\5\15\1\316\23\15\3\0"+
    "\1\15\30\0\1\15\2\0\2\15\3\0\4\15\1\317"+
    "\24\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\21\15\1\320\7\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\4\15\1\321\24\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\2\15\1\322\20\15\1\323"+
    "\5\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\2\15\1\324\26\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\1\325\30\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\1\326\30\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\1\327\5\15\1\330\22\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\5\15"+
    "\1\331\13\15\1\332\7\15\3\0\1\15\45\0\1\333"+
    "\107\0\1\334\36\0\5\220\1\335\73\220\1\336\1\335"+
    "\67\220\6\0\1\15\2\0\2\15\3\0\2\15\1\337"+
    "\26\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\1\340\30\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\21\15\1\341\7\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\6\15\1\342\22\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\6\15\1\343\22\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\6\15"+
    "\1\344\22\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\1\15\1\345\27\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\4\15\1\346\24\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\1\347\30\15\3\0"+
    "\1\15\30\0\1\15\2\0\2\15\3\0\6\15\1\350"+
    "\22\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\4\15\1\351\24\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\10\15\1\352\20\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\6\15\1\353\22\15\3\0"+
    "\1\15\30\0\1\15\2\0\2\15\3\0\6\15\1\354"+
    "\22\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\3\15\1\355\25\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\2\15\1\356\26\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\1\357\5\15\1\360\22\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\1\15"+
    "\1\361\27\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\12\15\1\362\16\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\12\15\1\363\16\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\15\15\1\364\13\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\6\15"+
    "\1\365\22\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\1\15\1\366\27\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\3\15\1\367\25\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\10\15\1\370\20\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\3\15"+
    "\1\371\25\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\2\15\1\372\26\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\6\15\1\373\22\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\7\15\1\374\21\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\2\15"+
    "\1\375\26\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\4\15\1\376\24\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\7\15\1\377\5\15\1\u0100\13\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\7\15"+
    "\1\u0101\2\15\1\u0102\16\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\2\15\1\u0103\26\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\20\15\1\u0104\10\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\6\15"+
    "\1\u0105\22\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\6\15\1\u0106\22\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\20\15\1\u0107\10\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\6\15\1\u0108\22\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\6\15"+
    "\1\u0109\22\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\15\15\1\u010a\13\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\27\15\1\u010b\1\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\10\15\1\u010c\17\15"+
    "\1\u010d\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\2\15\1\u010e\26\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\12\15\1\u010f\16\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\21\15\1\u0110\7\15\3\0"+
    "\1\15\30\0\1\15\2\0\2\15\3\0\21\15\1\u0111"+
    "\7\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\6\15\1\u0112\22\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\16\15\1\u0113\12\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\12\15\1\u0114\16\15\3\0"+
    "\1\15\30\0\1\15\2\0\2\15\3\0\21\15\1\u0115"+
    "\7\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\25\15\1\u0116\3\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\4\15\1\u0117\24\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\26\15\1\u0118\2\15\3\0"+
    "\1\15\30\0\1\15\2\0\2\15\3\0\2\15\1\u0119"+
    "\26\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\2\15\1\u011a\26\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\21\15\1\u011b\7\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\5\15\1\u011c\23\15\3\0"+
    "\1\15\30\0\1\15\2\0\2\15\3\0\3\15\1\u011d"+
    "\25\15\3\0\1\15\43\0\1\u011e\112\0\1\u011f\35\0"+
    "\4\220\1\10\1\335\67\220\6\0\1\15\2\0\2\15"+
    "\3\0\1\15\1\u0120\27\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\1\15\1\u0121\27\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\21\15\1\u0122\7\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\12\15"+
    "\1\u0123\16\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\5\15\1\u0124\23\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\20\15\1\u0125\10\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\5\15\1\u0126\23\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\6\15"+
    "\1\u0127\22\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\17\15\1\u0128\11\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\23\15\1\u0129\5\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\2\15\1\u012a\26\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\2\15"+
    "\1\u012b\26\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\2\15\1\u012c\26\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\4\15\1\u012d\24\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\1\15\1\u012e\27\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\6\15"+
    "\1\u012f\22\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\21\15\1\u0130\7\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\6\15\1\u0131\22\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\6\15\1\u0132\22\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\7\15"+
    "\1\u0133\21\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\5\15\1\u0134\23\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\6\15\1\u0135\22\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\6\15\1\u0136\22\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\6\15"+
    "\1\u0137\22\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\6\15\1\u0138\22\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\20\15\1\u0139\10\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\17\15\1\u013a\11\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\5\15"+
    "\1\u013b\23\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\1\15\1\u013c\27\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\17\15\1\u013d\11\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\5\15\1\u013e\23\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\1\15"+
    "\1\u013f\27\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\2\15\1\u0140\26\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\12\15\1\u0141\16\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\6\15\1\u0142\22\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\1\u0143"+
    "\30\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\2\15\1\u0144\26\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\10\15\1\u0145\20\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\20\15\1\u0146\10\15\3\0"+
    "\1\15\30\0\1\15\2\0\2\15\3\0\6\15\1\u0147"+
    "\22\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\6\15\1\u0148\22\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\5\15\1\u0149\23\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\1\u014a\30\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\6\15\1\u014b\22\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\6\15"+
    "\1\u014c\22\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\6\15\1\u014d\22\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\6\15\1\u014e\22\15\3\0\1\15"+
    "\46\0\1\u014f\100\0\1\u0150\52\0\1\15\2\0\2\15"+
    "\3\0\1\u0151\30\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\12\15\1\u0152\16\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\10\15\1\u0153\20\15\3\0"+
    "\1\15\30\0\1\15\2\0\2\15\3\0\12\15\1\u0154"+
    "\16\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\3\15\1\u0155\25\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\12\15\1\u0156\16\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\5\15\1\u0157\23\15\3\0"+
    "\1\15\30\0\1\15\2\0\2\15\3\0\1\15\1\u0158"+
    "\27\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\6\15\1\u0159\22\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\3\15\1\u015a\25\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\4\15\1\u015b\24\15\3\0"+
    "\1\15\30\0\1\15\2\0\2\15\3\0\12\15\1\u015c"+
    "\16\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\2\15\1\u015d\26\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\1\u015e\30\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\12\15\1\u015f\16\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\5\15\1\u0160\23\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\10\15"+
    "\1\u0161\20\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\1\15\1\u0162\27\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\21\15\1\u0163\7\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\2\15\1\u0164\26\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\10\15"+
    "\1\u0165\20\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\12\15\1\u0166\16\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\2\15\1\u0167\26\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\26\15\1\u0168\2\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\2\15"+
    "\1\u0169\26\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\1\15\1\u016a\27\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\7\15\1\u016b\21\15\3\0\1\15"+
    "\30\0\1\15\2\0\2\15\3\0\6\15\1\u016c\22\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\6\15"+
    "\1\u016d\22\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\1\15\1\u016e\27\15\3\0\1\15\46\0\1\u016f"+
    "\56\0\1\15\2\0\2\15\3\0\2\15\1\u0170\26\15"+
    "\3\0\1\15\30\0\1\15\2\0\2\15\3\0\6\15"+
    "\1\u0171\22\15\3\0\1\15\30\0\1\15\2\0\2\15"+
    "\3\0\6\15\1\u0172\22\15\3\0\1\15\30\0\1\15"+
    "\2\0\2\15\3\0\13\15\1\u0173\1\u0174\14\15\3\0"+
    "\1\15\30\0\1\15\2\0\2\15\3\0\6\15\1\u0175"+
    "\22\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\21\15\1\u0176\7\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\6\15\1\u0177\22\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\7\15\1\u0178\21\15\3\0"+
    "\1\15\30\0\1\15\2\0\2\15\3\0\2\15\1\u0179"+
    "\26\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\12\15\1\u017a\16\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\2\15\1\u017b\26\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\6\15\1\u017c\22\15\3\0"+
    "\1\15\30\0\1\15\2\0\2\15\3\0\2\15\1\u017d"+
    "\26\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\4\15\1\u017e\24\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\27\15\1\u017f\1\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\26\15\1\u0180\2\15\3\0"+
    "\1\15\30\0\1\15\2\0\2\15\3\0\1\15\1\u0181"+
    "\27\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\6\15\1\u0182\22\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\1\15\1\u0183\27\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\22\15\1\u0184\6\15\3\0"+
    "\1\15\30\0\1\15\2\0\2\15\3\0\17\15\1\u0185"+
    "\11\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\17\15\1\u0186\11\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\12\15\1\u0187\16\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\21\15\1\u0188\7\15\3\0"+
    "\1\15\30\0\1\15\2\0\2\15\3\0\2\15\1\u0189"+
    "\26\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\23\15\1\u018a\5\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\17\15\1\u018b\11\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\5\15\1\u018c\23\15\3\0"+
    "\1\15\30\0\1\15\2\0\2\15\3\0\4\15\1\u018d"+
    "\24\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\6\15\1\u018e\22\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\23\15\1\u018f\5\15\3\0\1\15\30\0"+
    "\1\15\2\0\2\15\3\0\6\15\1\u0190\22\15\3\0"+
    "\1\15\30\0\1\15\2\0\2\15\3\0\2\15\1\u0191"+
    "\26\15\3\0\1\15\30\0\1\15\2\0\2\15\3\0"+
    "\6\15\1\u0192\22\15\3\0\1\15\30\0\1\15\2\0"+
    "\2\15\3\0\1\15\1\u0193\27\15\3\0\1\15\22\0";

  private static int [] zzUnpackTrans() {
    int [] result = new int[17019];
    int offset = 0;
    offset = zzUnpackTrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackTrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /* error codes */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  private static final int ZZ_NO_MATCH = 1;
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /* error messages for the codes above */
  private static final String ZZ_ERROR_MSG[] = {
    "Unkown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state <code>aState</code>
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\5\0\1\11\1\1\1\11\1\1\1\11\1\1\1\11"+
    "\2\1\1\11\24\1\1\11\3\1\1\11\1\1\5\11"+
    "\1\1\1\11\1\1\1\11\1\1\1\11\1\1\1\11"+
    "\1\1\2\11\1\1\1\0\1\1\1\11\2\0\1\1"+
    "\2\0\1\11\72\1\3\11\2\0\15\11\2\0\1\11"+
    "\110\1\3\0\100\1\2\0\57\1\1\11\1\0\36\1"+
    "\1\11\44\1";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[403];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** the input device */
  private java.io.Reader zzReader;

  /** the current state of the DFA */
  private int zzState;

  /** the current lexical state */
  private int zzLexicalState = YYINITIAL;

  /** this buffer contains the current text to be matched and is
      the source of the yytext() string */
  private char zzBuffer[] = new char[ZZ_BUFFERSIZE];

  /** the textposition at the last accepting state */
  private int zzMarkedPos;

  /** the current text position in the buffer */
  private int zzCurrentPos;

  /** startRead marks the beginning of the yytext() string in the buffer */
  private int zzStartRead;

  /** endRead marks the last character in the buffer, that has been read
      from input */
  private int zzEndRead;

  /** number of newlines encountered up to the start of the matched text */
  private int yyline;

  /** the number of characters up to the start of the matched text */
  private int yychar;

  /**
   * the number of characters from the last newline up to the start of the 
   * matched text
   */
  private int yycolumn;

  /** 
   * zzAtBOL == true <=> the scanner is currently at the beginning of a line
   */
  private boolean zzAtBOL = true;

  /** zzAtEOF == true <=> the scanner is at the EOF */
  private boolean zzAtEOF;

  /** denotes if the user-EOF-code has already been executed */
  private boolean zzEOFDone;

  /* user code: */
   StringBuffer string = new StringBuffer();
   static String yyfile = "";
   private Symbol symbol(int type) {
     return new Symbol(type, yyline, yycolumn);
   }
   private Symbol symbol(int type, Object value) {
     return new Symbol(type, yyline, yycolumn, value);
   }


  /**
   * Creates a new scanner
   * There is also a java.io.InputStream version of this constructor.
   *
   * @param   in  the java.io.Reader to read input from.
   */
  Scanner(java.io.Reader in) {
    this.zzReader = in;
  }

  /**
   * Creates a new scanner.
   * There is also java.io.Reader version of this constructor.
   *
   * @param   in  the java.io.Inputstream to read input from.
   */
  Scanner(java.io.InputStream in) {
    this(new java.io.InputStreamReader(in));
  }

  /** 
   * Unpacks the compressed character translation table.
   *
   * @param packed   the packed character translation table
   * @return         the unpacked character translation table
   */
  private static char [] zzUnpackCMap(String packed) {
    char [] map = new char[0x10000];
    int i = 0;  /* index in packed string  */
    int j = 0;  /* index in unpacked array */
    while (i < 140) {
      int  count = packed.charAt(i++);
      char value = packed.charAt(i++);
      do map[j++] = value; while (--count > 0);
    }
    return map;
  }


  /**
   * Refills the input buffer.
   *
   * @return      <code>false</code>, iff there was new input.
   * 
   * @exception   java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead-zzStartRead);

      /* translate stored positions */
      zzEndRead-= zzStartRead;
      zzCurrentPos-= zzStartRead;
      zzMarkedPos-= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length) {
      /* if not: blow it up */
      char newBuffer[] = new char[zzCurrentPos*2];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
    }

    /* finally: fill the buffer with new input */
    int numRead = zzReader.read(zzBuffer, zzEndRead,
                                            zzBuffer.length-zzEndRead);

    if (numRead > 0) {
      zzEndRead+= numRead;
      return false;
    }
    // unlikely but not impossible: read 0 characters, but not at end of stream    
    if (numRead == 0) {
      int c = zzReader.read();
      if (c == -1) {
        return true;
      } else {
        zzBuffer[zzEndRead++] = (char) c;
        return false;
      }     
    }

	// numRead < 0
    return true;
  }

    
  /**
   * Closes the input stream.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true;            /* indicate end of file */
    zzEndRead = zzStartRead;  /* invalidate buffer    */

    if (zzReader != null)
      zzReader.close();
  }


  /**
   * Resets the scanner to read from a new input stream.
   * Does not close the old reader.
   *
   * All internal variables are reset, the old input stream 
   * <b>cannot</b> be reused (internal buffer is discarded and lost).
   * Lexical state is set to <tt>ZZ_INITIAL</tt>.
   *
   * @param reader   the new input stream 
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzAtBOL  = true;
    zzAtEOF  = false;
    zzEOFDone = false;
    zzEndRead = zzStartRead = 0;
    zzCurrentPos = zzMarkedPos = 0;
    yyline = yychar = yycolumn = 0;
    zzLexicalState = YYINITIAL;
  }


  /**
   * Returns the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   */
  public final String yytext() {
    return new String( zzBuffer, zzStartRead, zzMarkedPos-zzStartRead );
  }


  /**
   * Returns the character at position <tt>pos</tt> from the 
   * matched text. 
   * 
   * It is equivalent to yytext().charAt(pos), but faster
   *
   * @param pos the position of the character to fetch. 
   *            A value from 0 to yylength()-1.
   *
   * @return the character at position pos
   */
  public final char yycharat(int pos) {
    return zzBuffer[zzStartRead+pos];
  }


  /**
   * Returns the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occured while scanning.
   *
   * In a wellformed scanner (no or only correct usage of 
   * yypushback(int) and a match-all fallback rule) this method 
   * will only be called with things that "Can't Possibly Happen".
   * If this method is called, something is seriously wrong
   * (e.g. a JFlex bug producing a faulty scanner etc.).
   *
   * Usual syntax/scanner level error handling should be done
   * in error fallback rules.
   *
   * @param   errorCode  the code of the errormessage to display
   */
  private void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    }
    catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  } 


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * They will be read again by then next call of the scanning method
   *
   * @param number  the number of characters to be read again.
   *                This number must not be greater than yylength()!
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }


  /**
   * Contains user EOF-code, which will be executed exactly once,
   * when the end of file is reached
   */
  private void zzDoEOF() throws java.io.IOException {
    if (!zzEOFDone) {
      zzEOFDone = true;
      yyclose();
    }
  }


  /**
   * Resumes scanning until the next regular expression is matched,
   * the end of input is encountered or an I/O-Error occurs.
   *
   * @return      the next token
   * @exception   java.io.IOException  if any I/O-Error occurs
   */
  public java_cup.runtime.Symbol next_token() throws java.io.IOException {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char [] zzBufferL = zzBuffer;
    char [] zzCMapL = ZZ_CMAP;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      for (zzCurrentPosL = zzStartRead; zzCurrentPosL < zzMarkedPosL;
                                                             zzCurrentPosL++) {
        switch (zzBufferL[zzCurrentPosL]) {
        case '\u000B':
        case '\u000C':
        case '\u0085':
        case '\u2028':
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn++;
        }
      }

      if (zzR) {
        // peek one character ahead if it is \n (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof) 
            zzPeek = false;
          else 
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      if (zzMarkedPosL > zzStartRead) {
        switch (zzBufferL[zzMarkedPosL-1]) {
        case '\n':
        case '\u000B':
        case '\u000C':
        case '\u0085':
        case '\u2028':
        case '\u2029':
          zzAtBOL = true;
          break;
        case '\r': 
          if (zzMarkedPosL < zzEndReadL)
            zzAtBOL = zzBufferL[zzMarkedPosL] != '\n';
          else if (zzAtEOF)
            zzAtBOL = false;
          else {
            boolean eof = zzRefill();
            zzMarkedPosL = zzMarkedPos;
            zzEndReadL = zzEndRead;
            zzBufferL = zzBuffer;
            if (eof) 
              zzAtBOL = false;
            else 
              zzAtBOL = zzBufferL[zzMarkedPosL] != '\n';
          }
          break;
        default:
          zzAtBOL = false;
        }
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;
  
      if (zzAtBOL)
        zzState = ZZ_LEXSTATE[zzLexicalState+1];
      else
        zzState = ZZ_LEXSTATE[zzLexicalState];


      zzForAction: {
        while (true) {
    
          if (zzCurrentPosL < zzEndReadL)
            zzInput = zzBufferL[zzCurrentPosL++];
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = zzBufferL[zzCurrentPosL++];
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMapL[zzInput] ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          int zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
        case 3: 
          { return symbol(sym.DIV);
          }
        case 143: break;
        case 16: 
          { return symbol(sym.ADD);
          }
        case 144: break;
        case 79: 
          { return symbol(sym.TYPE);
          }
        case 145: break;
        case 49: 
          { return symbol(sym.DBAR);
          }
        case 146: break;
        case 32: 
          { yyline = Integer.parseInt(yytext().trim(),10);yybegin(FILENAME);
          }
        case 147: break;
        case 17: 
          { return symbol(sym.MOD);
          }
        case 148: break;
        case 116: 
          { return symbol(sym.MORTAL);
          }
        case 149: break;
        case 55: 
          { return symbol(sym.ASSIGN);
          }
        case 150: break;
        case 106: 
          { return symbol(sym.WRITE);
          }
        case 151: break;
        case 36: 
          { return symbol(sym.IN);
          }
        case 152: break;
        case 19: 
          { return symbol(sym.CIRCUM);
          }
        case 153: break;
        case 96: 
          { return symbol(sym.EVENT);
          }
        case 154: break;
        case 109: 
          { return symbol(sym.VALUE);
          }
        case 155: break;
        case 141: 
          { return symbol(sym.DEADLOCKFREE);
          }
        case 156: break;
        case 111: 
          { return symbol(sym.UNLESS);
          }
        case 157: break;
        case 72: 
          { return symbol(sym.LTL);
          }
        case 158: break;
        case 41: 
          { return symbol(sym.OR);
          }
        case 159: break;
        case 27: 
          { return symbol(sym.LPAREN);
          }
        case 160: break;
        case 110: 
          { return symbol(sym.IFTRUE);
          }
        case 161: break;
        case 81: 
          { return symbol(sym.READ);
          }
        case 162: break;
        case 13: 
          { return symbol(sym.SUB);
          }
        case 163: break;
        case 46: 
          { return symbol(sym.ENDPATTERN);
          }
        case 164: break;
        case 100: 
          { return symbol(sym.ARRAY);
          }
        case 165: break;
        case 114: 
          { return symbol(sym.STATES);
          }
        case 166: break;
        case 89: 
          { return symbol(sym.T_BOOL);
          }
        case 167: break;
        case 95: 
          { return symbol(sym.ELSIF);
          }
        case 168: break;
        case 82: 
          { return symbol(sym.ELSE);
          }
        case 169: break;
        case 24: 
          { return symbol(sym.SEMICOLON);
          }
        case 170: break;
        case 92: 
          { return symbol(sym.UNTIL);
          }
        case 171: break;
        case 5: 
          { return symbol(sym.DOT);
          }
        case 172: break;
        case 40: 
          { return symbol(sym.ON);
          }
        case 173: break;
        case 126: 
          { return symbol(sym.ENQUEUE);
          }
        case 174: break;
        case 140: 
          { return symbol(sym.COMPONENT);
          }
        case 175: break;
        case 87: 
          { return symbol(sym.FULL);
          }
        case 176: break;
        case 50: 
          { return symbol(sym.RQBRACE);
          }
        case 177: break;
        case 65: 
          { return symbol(sym.TAG);
          }
        case 178: break;
        case 23: 
          { return symbol(sym.COLON);
          }
        case 179: break;
        case 86: 
          { return symbol(sym.LOOP);
          }
        case 180: break;
        case 69: 
          { return symbol(sym.AND);
          }
        case 181: break;
        case 115: 
          { return symbol(sym.SELECT);
          }
        case 182: break;
        case 125: 
          { return symbol(sym.RELEASE);
          }
        case 183: break;
        case 108: 
          { return symbol(sym.WHERE);
          }
        case 184: break;
        case 45: 
          { return symbol(sym.GE);
          }
        case 185: break;
        case 66: 
          { return symbol(sym.OUT);
          }
        case 186: break;
        case 131: 
          { return symbol(sym.PROCESS);
          }
        case 187: break;
        case 38: 
          { return symbol(sym.IF);
          }
        case 188: break;
        case 101: 
          { return symbol(sym.AFTER);
          }
        case 189: break;
        case 26: 
          { return symbol(sym.RBRACK);
          }
        case 190: break;
        case 39: 
          { return symbol(sym.TO);
          }
        case 191: break;
        case 118: 
          { return symbol(sym.APPEND);
          }
        case 192: break;
        case 142: 
          { return symbol(sym.INFINITELYOFTEN);
          }
        case 193: break;
        case 63: 
          { return symbol(sym.NOT);
          }
        case 194: break;
        case 9: 
          { return symbol(sym.SHARP);
          }
        case 195: break;
        case 90: 
          { return symbol(sym.WAIT);
          }
        case 196: break;
        case 44: 
          { return symbol(sym.IMP);
          }
        case 197: break;
        case 104: 
          { return symbol(sym.FIELD);
          }
        case 198: break;
        case 53: 
          { return symbol(sym.LTMID);
          }
        case 199: break;
        case 107: 
          { return symbol(sym.WHILE);
          }
        case 200: break;
        case 91: 
          { return symbol(sym.UNION);
          }
        case 201: break;
        case 122: 
          { return symbol(sym.BEFORE);
          }
        case 202: break;
        case 6: 
          { return symbol(sym.COMMA);
          }
        case 203: break;
        case 51: 
          { return symbol(sym.LE);
          }
        case 204: break;
        case 138: 
          { return symbol(sym.PROPERTY);
          }
        case 205: break;
        case 132: 
          { return symbol(sym.PRESENT);
          }
        case 206: break;
        case 112: 
          { return symbol(sym.RECORD);
          }
        case 207: break;
        case 98: 
          { return symbol(sym.QUEUE);
          }
        case 208: break;
        case 58: 
          { return symbol(sym.LQBRACE);
          }
        case 209: break;
        case 123: 
          { return symbol(sym.WITHIN);
          }
        case 210: break;
        case 78: 
          { return symbol(sym.TRUE);
          }
        case 211: break;
        case 139: 
          { return symbol(sym.PRECEDES);
          }
        case 212: break;
        case 42: 
          { return symbol(sym.OF);
          }
        case 213: break;
        case 52: 
          { return symbol(sym.NE);
          }
        case 214: break;
        case 76: 
          { return symbol(sym.NULL);
          }
        case 215: break;
        case 30: 
          { return symbol(sym.RBRACE);
          }
        case 216: break;
        case 67: 
          { return symbol(sym.END);
          }
        case 217: break;
        case 137: 
          { return symbol(sym.PRIORITY);
          }
        case 218: break;
        case 54: 
          { return symbol(sym.BEGINPATTERN);
          }
        case 219: break;
        case 7: 
          { return symbol(sym.IDENT,  yytext());
          }
        case 220: break;
        case 74: 
          { return symbol(sym.VAR);
          }
        case 221: break;
        case 34: 
          { return symbol(sym.TWODOT);
          }
        case 222: break;
        case 25: 
          { return symbol(sym.LBRACK);
          }
        case 223: break;
        case 133: 
          { return symbol(sym.LEADSTO);
          }
        case 224: break;
        case 47: 
          { return symbol(sym.ARROW);
          }
        case 225: break;
        case 57: 
          { return symbol(sym.NEXT);
          }
        case 226: break;
        case 102: 
          { return symbol(sym.LEAVE);
          }
        case 227: break;
        case 103: 
          { return symbol(sym.FIRST);
          }
        case 228: break;
        case 94: 
          { return symbol(sym.EMPTY);
          }
        case 229: break;
        case 22: 
          { return symbol(sym.SEND);
          }
        case 230: break;
        case 70: 
          { return symbol(sym.ANY);
          }
        case 231: break;
        case 130: 
          { return symbol(sym.DEQUEUE);
          }
        case 232: break;
        case 99: 
          { return symbol(sym.STATE);
          }
        case 233: break;
        case 119: 
          { return symbol(sym.ALWAYS);
          }
        case 234: break;
        case 80: 
          { return symbol(sym.THEN);
          }
        case 235: break;
        case 1: 
          { throw new Error("Illegal character <"+
                                        yytext()+">");
          }
        case 236: break;
        case 48: 
          { return symbol(sym.MIDGT);
          }
        case 237: break;
        case 68: 
          { return symbol(sym.PAR);
          }
        case 238: break;
        case 113: 
          { return symbol(sym.EXISTS);
          }
        case 239: break;
        case 59: 
          { yyfile = yytext().trim(); yybegin(ENDLINE);
          }
        case 240: break;
        case 18: 
          { return symbol(sym.AT);
          }
        case 241: break;
        case 8: 
          { return symbol(sym.NAT, yytext());
          }
        case 242: break;
        case 64: 
          { return symbol(sym.T_NAT);
          }
        case 243: break;
        case 75: 
          { return symbol(sym.INIT);
          }
        case 244: break;
        case 135: 
          { return symbol(sym.FOREACH);
          }
        case 245: break;
        case 56: 
          { return symbol(sym.ALT);
          }
        case 246: break;
        case 33: 
          { yybegin(YYINITIAL);
          }
        case 247: break;
        case 29: 
          { return symbol(sym.LBRACE);
          }
        case 248: break;
        case 128: 
          { return symbol(sym.CONSTR1);
          }
        case 249: break;
        case 136: 
          { return symbol(sym.BETWEEN);
          }
        case 250: break;
        case 61: 
          { return symbol(sym.DEC, yytext());
          }
        case 251: break;
        case 127: 
          { return symbol(sym.CONSTR0);
          }
        case 252: break;
        case 97: 
          { return symbol(sym.CONST);
          }
        case 253: break;
        case 121: 
          { return symbol(sym.LENGTH);
          }
        case 254: break;
        case 120: 
          { return symbol(sym.ABSENT);
          }
        case 255: break;
        case 93: 
          { return symbol(sym.ENTER);
          }
        case 256: break;
        case 12: 
          { return symbol(sym.GT);
          }
        case 257: break;
        case 85: 
          { return symbol(sym.PORT);
          }
        case 258: break;
        case 88: 
          { return symbol(sym.FROM);
          }
        case 259: break;
        case 2: 
          { /* ignore */
          }
        case 260: break;
        case 84: 
          { return symbol(sym.SYNC);
          }
        case 261: break;
        case 14: 
          { return symbol(sym.AMP);
          }
        case 262: break;
        case 11: 
          { return symbol(sym.EQ);
          }
        case 263: break;
        case 15: 
          { return symbol(sym.MID);
          }
        case 264: break;
        case 60: 
          { return symbol(sym.INFTY);
          }
        case 265: break;
        case 28: 
          { return symbol(sym.RPAREN);
          }
        case 266: break;
        case 124: 
          { return symbol(sym.IFFALSE);
          }
        case 267: break;
        case 117: 
          { return symbol(sym.ASSERT);
          }
        case 268: break;
        case 77: 
          { return symbol(sym.NONE);
          }
        case 269: break;
        case 43: 
          { return symbol(sym.DO);
          }
        case 270: break;
        case 73: 
          { return symbol(sym.FOR);
          }
        case 271: break;
        case 37: 
          { return symbol(sym.IS);
          }
        case 272: break;
        case 105: 
          { return symbol(sym.FALSE);
          }
        case 273: break;
        case 4: 
          { return symbol(sym.MUL);
          }
        case 274: break;
        case 129: 
          { return symbol(sym.CHANNEL);
          }
        case 275: break;
        case 83: 
          { return symbol(sym.CASE);
          }
        case 276: break;
        case 21: 
          { return symbol(sym.LT);
          }
        case 277: break;
        case 71: 
          { return symbol(sym.ALL);
          }
        case 278: break;
        case 20: 
          { return symbol(sym.COERCE);
          }
        case 279: break;
        case 35: 
          { return symbol(sym.STRING, yytext());
          }
        case 280: break;
        case 62: 
          { return symbol(sym.T_INT);
          }
        case 281: break;
        case 134: 
          { return symbol(sym.LASTING);
          }
        case 282: break;
        case 31: 
          { yybegin(LINENUMBER);
          }
        case 283: break;
        case 10: 
          { return symbol(sym.RCVE);
          }
        case 284: break;
        default: 
          if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
            zzAtEOF = true;
            zzDoEOF();
              { return new java_cup.runtime.Symbol(sym.EOF); }
          } 
          else {
            zzScanError(ZZ_NO_MATCH);
          }
      }
    }
  }


}
